	LOCALS @@

code	segment para public 'CODE'

	.386P

	org  0100h
	assume cs:code,ds:code,ss:nothing

StartUp:
;	 mov  ax,cs
;	 mov  ds,ax
;	 mov  ss,ax
	jmp  main

BKGND	equ  007h
BKGND32 equ  007070707h
LINECOL equ  008h

Back	dw 0	    ; disegno backface

SType	dw 0	    ; 0=Wireframe
		    ; 1=Hidden line
		    ; 2=Solid
		    ; 3=Texture
		    ; 4=Gouraud
		    ; 5=Phong

;NFrame  dw 0	     ; numero di frame totali
StarRad dw 0	    ; raggio stella
seed	dw 1	    ; seme per generazione numeri casuali
ddas	dw 0	    ; area di memorizzazione dda
plasma	dw 0	    ; area plasma clouds
lmod	dw 0	    ; area light model Gouraud
phong	dw 0	    ; area light model Phong
sine	dw 0	    ; area sine table
oldi8	dd 0	    ; vecchio Int8
I8Acc	dw 0	    ; accumulatore I8
Time	dw 0	    ; Contatore temporale
phase	dw 0	    ; contatore eventi

PlTL	dw 0	    ; Colore topleft
PlTR	dw 0	    ; Colore topright
PlBL	dw 0	    ; Colore bottomleft
PlBR	dw 0	    ; Colore bottomright

l1	dd 0	    ; Locazioni di appoggio per NewDDA
l2	dd 0
l3	dd 0
l4	dd 0

StarDir dw 1	    ; incremento raggio stella
basea	dw 16384    ; indirizzo di inizio pagina di lavoro
FontSeg dw 0F000h   ; segmento font 8x8 ROM
VidSeg	dw 0A000h   ; segmento video VGA
MixFreq dw 65536/8  ; parametri per velocizzazione Int8

banx	dw 400	    ; x scritta
txcol1	db 0	    ; flag di cambio colore

TXCOL2	equ 14	    ; colore flash testo
TXCOL0	equ 1	    ; colore testo

banner	db '@@Torus@#:-(#@'
	db 'ok, now this is a torus@#:-/#@'
	db 'hidden lines ! #:-)#@'
	db 'solid faces ! #:-)#@'
	db 'texture !! #:-o#@'
	db 'Gouraud !!! #:-))#@'
	db 'Phong ?! #Wow!!!! :-O#@@'
	db 'The End #(clap clap clap)#',0

PHASES	equ  9		; Numero fasi

events	dw   1050*2	; Torus 6x8 wireframe	  (SType=0)
	dw   1700*2	; Torus 12x24 wireframe   (SType=0)
	dw   2100*2	; Hidden lines		  (SType=1)
	dw   2500*2	; Solid 		  (SType=2)
	dw   2900*2	; Marble		  (SType=3)
	dw   3300*2	; Gouraud		  (SType=4)
	dw   4100*2	; Phong 		  (SType=5)
	dw   4600*2	; Mix			  (SType=*)
	dw   5131*2	; End			  (SType=*)

torflag dw   1			     ; flag di ricalcolo toro
Flag	dw   1			     ; flag di ralletnamento scritta

OOM	db 'Mem$'
CPUErr	db '386!$'
ByeBye  db 'By A.Griffini (6502).',13,10,'$'

	;
	; Impostazione palette = 32 standard + 7 colori x 32 sfumature
	;
Palette proc near
	mov  dx,03C8h
	mov  al,32
	out  dx,al
	inc  dx
	mov  bx,1
@@Loop1:
	mov  cl,1		; cl = intensita' componente
@@Loop2:
	mov  ch,cl
	shr  ch,1
	mov  al,ch
	test bl,4		; rosso = bit 2
	je   @@NoRed
	mov  al,cl
@@NoRed:
	out  dx,al
	mov  al,ch
	test bl,2		; verde = bit 1
	je   @@NoGreen
	mov  al,cl
@@NoGreen:
	out  dx,al
	mov  al,ch
	test bl,1		; blu = bit 0
	je   @@NoBlue
	mov  al,cl
@@NoBlue:
	out  dx,al

	add  cl,2
	cmp  cl,64
	jl   @@Loop2
	inc  bl
	cmp  bl,8
	jl   @@Loop1
	ret
Palette endp

	;
	; Restituisce una word casuale in dx
	;
randw	proc near
	call rand
	mov  dh,dl		; Nota: entra in rand...
randw	endp
	;
	; Restituisce un byte casuale in dl
	;
rand	proc near

	mov  dl,8
@@randloop:
	rol  seed,1
	jnc  @@NoXor
	xor  byte ptr seed,0Ah
@@NoXor:
	dec  dl
	jne  @@randloop
	mov  dl,byte ptr seed
	ret
rand	endp

;rand	 proc near
;	 push ax
;	 xor  ax,ax
;	 out  043h,al
;	 in   al,040h
;	 mov  dl,al
;	 pop  ax
;	 ret
;rand	 endp

;rand	 proc near
;	 push ax
;	 push bx
;	 push cx
;	 mov  cx,8
;@@1:
;	 mov  bx,seed
;	 mov  ax,bx
;	 shr  ax,3
;	 xor  bx,ax
;	 shr  ax,1
;	 xor  bx,ax
;	 shr  ax,1
;	 xor  bx,ax
;	 xor  bx,1
;	 shr  bx,1
;	 rcr  seed,1
;	 rcl  dl,1
;	 loop @@1
;	 pop  cx
;	 pop  bx
;	 pop  ax
;	 ret
;rand	 endp

;
; Interrupt 8 routine per scorrimento scritta
;
NewInt8 proc near
	;
	; Salva i registri
	;
	pusha
	push  ds

	;
	; Imposta ds corretto
	;
	push  cs
	pop   ds

;	 ;
;	 ; Assegna grigi casuali ai colori 16..31
;	 ;
;	 mov   dx,03C8h
;	 mov   al,16
;	 out   dx,al
;	 mov   si,16
;@@1:
;	 call  rand
;	 mov   al,dl
;	 and   al,31
;	 mov   dx,03C9h
;	 out   dx,al
;	 out   dx,al
;	 out   dx,al
;	 dec   si
;	 jne   @@1

	;
	; Sposta scritta
	;
	xor   Flag,1
	je    @@NoDec
	dec   banx
	test  banx,15
	jne   @@NoFlip
	xor   txcol1,TXCOL2
@@NoFLip:
	;
	; Gestione stella rotante
	;
	mov  ax,StarRad
	add  ax,StarDir
	jge  @@Ok
	xor  ax,ax
@@Ok:
	mov  StarRad,ax
@@NoDec:

	;
	; Incrementa gli angoli
	;
	mov  ax,2047
	add  AA0,4
	and  AA0,ax
	add  BB0,3
	and  BB0,ax
	add  CC0,2
	and  CC0,ax

	;
	; Aggiorna orologio
	;
	inc  Time

	mov  al,20h
	out  20h,al
	pop  ds
	popa
	iret

;	 ;
;	 ; Aggiorna orologio relativo
;	 ;
;	 mov   ax,MixFreq
;	 stc
;	 adc   I8Acc,ax
;
;	 ;
;	 ; Recupera registri
;	 ;
;	 pop   ds
;	 popa
;	 push  ax
;
;	 jc    @@Orig		 ; Se CF=1 deve chiamare l'interrupt originale
;
;	 mov   al,020h		 ; Esce direttamente
;	 out   020h,al
;	 pop   ax
;	 iret
;
;@@Orig:
;	 ;
;	 ; Esegue l'interrupt handler originale
;	 ;
;	 pop   ax
;	 jmp   dword ptr cs:[OldI8]

NewInt8 endp

; ---------------------------------
; Plasma clouds per calcolo texture
; ---------------------------------

;
; Calcola CX = Max(0,Min(255,CX + Random(DX) - DX/2))
;
Rand1	proc near
	push ax 		; salva i registri
	push dx
	push cx
	push bx

	imul dx,4		; delta = delta*18+20
	add  dx,20

	;
	; Calcola dx = random(delta)-delta/2
	;
	push dx

	call randw
	mov  ax,dx	; dx:ax = random(65536)
	xor  dx,dx

	pop  cx 	; cx = delta
	push cx
	div  cx 	; dx = dx:ax mod delta

	pop  cx 	; dx = dx - delta/2
	shr  cx,1
	sub  dx,cx

	pop  bx
	pop  cx

	add  cx,dx		; random offset
	jge  @@NoMin
	xor  cx,cx
@@NoMin:
	mov  ax,255
	cmp  cx,ax
	jle  @@NoMax
	mov  cx,ax
@@NoMax:
	pop  dx 		; Recupera delta
	pop  ax
	ret
Rand1	endp

PlasmaC proc near
	mov  es,Plasma
	mov  dx,256		; dx = delta
	xor  bx,bx		; bx = 0,0 pixel ptr
	mov  byte ptr es:[bx],128 ; valore base
@@Loop1:

	;
	; Plot punto centrale
	;
	xor  cx,cx		; cx = Accumulatore colore
	mov  ah,0
	mov  al,es:[bx] 	; Plasma(x,y)
	mov  PlTL,ax		; Salva colore letto
	add  cx,ax
	add  bl,dl
	mov  al,es:[bx] 	; Plasma(x+delta,y)
	mov  PlTR,ax		; Salva colore letto
	add  cx,ax
	add  bh,dl
	mov  al,es:[bx] 	; Plasma(x+delta,y+delta)
	mov  PlBR,ax		; Salva colore letto
	add  cx,ax
	sub  bl,dl
	mov  al,es:[bx] 	; Plasma(x,y+delta)
	mov  PlBL,ax		; Salva colore letto
	add  cx,ax
	sub  bh,dl		; Ripristina bx

	add  cx,2		; Calcola la media
	shr  cx,2
	call Rand1		; Random shift
	mov  si,bx		; Plot(x+delta/2,y+delta/2)
	mov  ax,dx
	shr  ax,1
	add  bl,al
	add  bh,al
	mov  es:[bx],cl
	mov  bx,si

	mov  ax,dx		; ax = delta/2
	shr  ax,1

	;
	; Plot punto superiore (solo se y=0)
	;
;	test bh,bh
;	jne  @@Top
	mov  cx,PlTL
	add  cx,PlTR
	inc  cx
	shr  cx,1
	call Rand1
	add  bl,al
	mov  es:[bx],cl 	; Plot(x+delta/2,y)
	mov  bx,si
@@Top:
	;
	; Plot punto inferiore
	;
	mov  cx,PlBL
	add  cx,PlBR
	inc  cx
	shr  cx,1
	call Rand1
	add  bl,al
	add  bh,dl
	mov  es:[bx],cl 	; Plot(x+delta/2,y+delta)
	mov  bx,si

	;
	; Plot punto sinistro (solo se x=0)
	;
;	test bl,bl
;	jne  @@Left
	mov  cx,PlTL
	add  cx,PlBL
	inc  cx
	shr  cx,1
	call Rand1
	add  bh,al
	mov  es:[bx],cl 	; Plot(x,y+delta/2)
	mov  bx,si
@@Left:
	;
	; Plot punto destro
	;
	mov  cx,PlTR
	add  cx,PlBR
	inc  cx
	shr  cx,1
	call Rand1
	add  bl,dl
	add  bh,al
	mov  es:[bx],cl 	; Plot(x+delta,y+delta/2)
	mov  bx,si

	;
	; Incremento coordinate
	;
	add  bl,dl
	test bl,bl
	jne  @@NoDown
	add  bh,dl		; Sposta a y+delta
@@NoDown:
	test bx,bx
	jne  @@Loop1
	shr  dx,1		; delta = delta/2
	cmp  dx,1
	ja   @@Loop1

	;
	; Scaling nel range 0..15
	;
@@Scale:
	shr  byte ptr es:[bx],4
	inc  bx
	jne  @@Scale
	ret
PlasmaC endp

; ----------
; Sine table
; ----------

;;
;; Tabella base: 65 word rappresentano il primo quarto di y = sen(x)*32767
;;
;SineTab dw   0,804,1608,2410,3212,4011,4808,5602
;	 dw   6393,7179,7962,8739,9512,10278,11039,11793
;	 dw   12539,13279,14010,14732,15446,16151,16846,17530
;	 dw   18204,18868,19519,20159,20787,21403,22005,22594
;	 dw   23170,23731,24279,24811,25329,25832,26319,26790
;	 dw   27245,27683,28105,28510,28898,29268,29621,29956
;	 dw   30273,30571,30852,31113,31356,31580,31785,31971
;	 dw   32137,32285,32412,32521,32609,32678,32728,32757
;	 dw   32767
;;
;; Viene calcolata la tabella completa seno-coseno (2PI = 1024) per
;; interpolazione lineare.
;; La tabella seno parte a SINE:[0], il coseno parte a SINE:[256].
;;
;CalcSine proc near
;	 mov  es,sine
;	 xor  si,si		 ; puntatore di lettura (crescente)
;	 mov  bx,128		 ; puntatore di lettura (decrescente)
;	 xor  di,di		 ; scrittura
;	 mov  cx,64
;	 ;
;	 ; Scrittura valori base
;	 ;
;@@Loop1:
;	 mov  ax,SineTab[si]	 ; arco crescente
;	 mov  es:[di],ax
;	 mov  es:[di+1024],ax
;	 neg  ax
;	 mov  es:[di+512],ax
;
;	 mov  ax,SineTab[bx]	 ; arco decrescente
;	 mov  es:[di+256],ax
;	 neg  ax
;	 mov  es:[di+768],ax
;
;	 add  di,4
;	 sub  bx,2
;	 add  si,2
;	 loop @@Loop1
;
;	 mov  ax,es:[256]	 ; Copia ultimo valore per interpolazione
;	 mov  es:[1280],ax
;
;	 ;
;	 ; Interpolazione
;	 ;
;	 xor  di,di
;@@Loop2:
;	 movsx eax,word ptr es:[di]
;	 movsx ebx,word ptr es:[di+4]
;	 add  eax,ebx
;	 sar  eax,1
;	 mov  es:[di+2],ax
;	 add  di,4
;	 cmp  di,1280
;	 jne  @@Loop2
;	 ret
;CalcSine endp

sin		dd	?
cos		dd	?

CalcSine proc near
	xor cx,cx
	mov ebp,40000000h	;ebp = 1.0
	xor edi,edi		;x
lop3:
	mov bx,2
	mov sin,edi
	mov cos,ebp
lop2:
	call hunf		;(per Andrea) noterai che dopo una certa ora
	sub cos,eax		;perdo la voglia di inventarmi delle labels
	call hunf		;che abbiano un significato :)
	sub sin,eax
	call hunf
	add cos,eax
	call hunf
	add sin,eax
	cmp bl,10		;ci fermiamo al quinto termine
	jne lop2

	add edi,6588397 	;(2*pi/1024)*2^30
	mov esi,08001h
	mov eax,cos
	cdq
	idiv esi
	mov bx,ax
	mov eax,sin
	cdq
	idiv esi
	mov si,cx

	push ds
	mov ds,sine

	mov [si],ax
	mov [si+512],bx
	mov [si+2048],ax
	neg ax
	neg bx
	mov [si+1024],ax
	mov [si+1536],bx

	pop ds
	inc cx			;stupido, ma piu' corto di add cx,2
	inc cx
	test ch,2		;meno stupido e piu' corto di cmp cx,512
	jz lop3
	ret
Calcsine endp

hunf	proc near		;(edi^bx)/(bx!) bx++

	push cx
	mov cx,bx
	inc bx
	mov eax,ebp
lop:
	mov esi,edi
	imul esi
	movzx esi,cl
	shrd eax,edx,30
	cdq
	idiv esi
	loop lop
	pop cx
	ret
hunf	endp

; ----------------------
; Polygon scan converter
; ----------------------

DDAY	equ   0 	    ; Y iniziale dda
DDADY	equ   2 	    ; dimensione verticale

DDAXH	equ   4 	    ; X corrente
DDAXL	equ   6 	    ; accumulatore X
DDASXL	equ   8 	    ; velocita' (low)
DDASXH	equ   10	    ; velocita' (high)

DDAAH	equ   12	    ; A corrente
DDAAL	equ   14	    ; accumulatore A
DDASAL	equ   16	    ; velocita' (low)
DDASAH	equ   18	    ; velocita' (high)

DDABH	equ   20	    ; B corrente
DDABL	equ   22	    ; accumulatore B
DDASBL	equ   24	    ; velocita' (low)
DDASBH	equ   26	    ; velocita' (high)

DDANEXT equ   28	    ; prossimo dda
DDASZ	equ   30	    ; dimensione totale di un dda

y0	dw    0 	    ; ordinata minima
asc	dw    0 	    ; dda ascendente
des	dw    0 	    ; dda discendente

ddafrst dw    0 	    ; primo dda (offset in ddas)
actdda	dw    0 	    ; dda attivo (offset in ddas)
ndda	dw    0 	    ; puntatore per allocazione dda (offset in ddas)
X0	dw    32 dup (0)    ; dda attivi ordinati per x crescente (max 16!!!)
			    ; X0 dda0 X1 dda1 ... XN ddaN
nx	dw    0 	    ; numero di dda nel vettore X0 ( x 4 )
color	dw    0 	    ; colore poligono
txbase	db    0 	    ; offset in texture
cv	dw    0 	    ; vertice corrente
nv	dw    0 	    ; numero vertici poligono

LMask0	db    0Fh,0Eh,0Ch,08h
RMask0	db    01h,03h,07h,0Fh
PMask0	db    01h,02h,04h,08h

;
; Inizializzazione polygon scan converter
;
InitPoly proc near
	xor   di,di	    ; puntatore di scrittura su HOffs
	xor   si,si	    ; puntatore pixel
	mov   cx,320
@@Loop1:
	mov   ax,si
	shr   ax,2
	mov   word ptr HOffs[di],ax
	mov   bx,si
	and   bx,3
	mov   al,LMask0[bx]
	mov   byte ptr LMask[si],al
	mov   al,RMask0[bx]
	mov   byte ptr RMask[si],al
	mov   al,PMask0[bx]
	mov   byte ptr PMask[si],al
	inc   si
	add   di,2
	loop  @@Loop1
	ret
InitPoly endp

;
; Nuovo poligono
; AX = Numero di vertici
NewPoly proc near
	mov  nv,ax
	xor  ax,ax
	mov  cv,ax	    ; cv = numero punti gia' considerati
	mov  ndda,ax
	dec  ax
	mov  ddafrst,ax
	mov  actdda,ax
	mov  y0,400
	ret
NewPoly endp

;
; Aggiunge un nuovo dda
; ax=x0, bx=y0, cx=x1, dx=y1	      (coordinate video)
; eaxh=a0, ebxh=b0, ecxh=a1, edxh=b1  (coordinate texture)
;
NewDDA	proc near
	push si 	; Salva registri coinvolti
	push di
	push fs
	cmp  SType,2	; Poligono con texture ?
	jle  @@NoFlip	; No
	;
	; I poligoni con texture sono disegnati da sinistra a destra,
	; quelli solid dall'alto in basso.
	;
	xchg ax,bx	; N.B.: non scambia le coordinate texture
	xchg cx,dx
@@NoFlip:
	mov  di,ndda	; indirizzo dda in fase di allocazione
	cmp  bx,dx
	je   @@Done	; DDA orizzontali sono inutili
	jl   @@NoSwap
	xchg eax,ecx	; Linea ascendente, inverti
	xchg ebx,edx
	cmp  bx,y0
	jg   @@Swapped
	mov  y0,bx	; salva dda ascendente
	mov  asc,di
	jmp  @@swapped
@@NoSwap:
	cmp  bx,y0
	jg   @@Swapped
	mov  y0,bx	; salva dda discendente
	mov  des,di
@@Swapped:
	mov  fs,ddas		  ; alloca un nuovo dda
	add  ndda,DDASZ

	mov  fs:[di+DDAY],bx	  ; registra y iniziale
	sub  dx,bx		  ; calcola e registra durata in scanline
	mov  fs:[di+DDADY],dx

	mov  l1,eax		  ; Salva registri in locazioni di appoggio
	mov  l2,ebx
	mov  l3,ecx
	mov  l4,edx

	;
	; Impostazione integratore per -X-
	;
	mov  fs:[di+DDAXH],ax	  ; registra x iniziale
	mov  word ptr fs:[di+DDAXL],32767
	movzx ebx,word ptr fs:[di+DDADY]   ; EBX = denominatore
	sub  ax,cx		  ; EDX:EAX = numeratore
	neg  ax
	shl  eax,16
	cdq
	idiv ebx

	mov  fs:[di+DDASXL],ax	  ; salva il risultato divisione
	shr  eax,16
	mov  fs:[di+DDASXH],ax

	cmp  SType,2
	jle  @@NoAB		  ; risparima i calcoli se non c'e' texture

	;
	; Impostazione integratore per -A-
	;
	mov  ax,word ptr l1[2]	  ; ax = A0
	mov  cx,word ptr l3[2]	  ; cx = A1
	mov  fs:[di+DDAAH],ax	  ; registra a iniziale
	mov  word ptr fs:[di+DDAAL],32767
	sub  ax,cx		  ; EDX:EAX = numeratore
	neg  ax
	shl  eax,16
	cdq
	idiv ebx

	mov  fs:[di+DDASAL],ax	  ; salva il risultato divisione
	shr  eax,16
	mov  fs:[di+DDASAH],ax

	;
	; Impostazione integratore per -B-
	;
	mov  ax,word ptr l2[2]	  ; ax = B0
	mov  cx,word ptr l4[2]	  ; cx = B1
	mov  fs:[di+DDABH],ax	  ; registra b iniziale
	mov  word ptr fs:[di+DDABL],32767
	sub  ax,cx		  ; EDX:EAX = numeratore
	neg  ax
	shl  eax,16
	cdq
	idiv ebx

	mov  fs:[di+DDASBL],ax	  ; salva il risultato divisione
	shr  eax,16
	mov  fs:[di+DDASBH],ax

@@NoAB:

	;
	; Inserisce in lista ordinata per Y crescente
	;
	mov  bx,-1		  ; puntatore a dda precedente
	mov  si,ddafrst 	  ; puntatore a dda successivo
	mov  dx,fs:[di+DDAY]	  ; dx ordinata iniziale del nuovo dda
@@YInsLoop:
	cmp  si,0
	jl   @@Found
	cmp  dx,fs:[si+DDAY]
	jle  @@Found
	mov  bx,si
	mov  si,fs:[si+DDANEXT]
	jmp  @@YInsLoop
@@Found:
	mov  fs:[di+DDANEXT],si
	cmp  bx,-1
	je   @@FirstDDA
	mov  fs:[bx+DDANEXT],di
	jmp  @@Done
@@FirstDDA:
	mov  ddafrst,di
@@Done:
	pop  fs
	pop  di
	pop  si
	ret
NewDDA	endp

;
; Riempimento poligono
;
Fill	proc near
	;
	; Gestione tipi di poligono solid
	;    (assente, black, colorato)
	;
	cmp  SType,0
	jne  @@MayBe
	ret		    ; assente (wireframe)
@@MayBe:
	cmp  SType,3
	jge  @@DoYes	    ; textured / gouraud / phong
	cmp  SType,1
	jne  @@DoYes	    ; solid
	mov  Color,BKGND    ; (hidden lines)
@@DoYes:
	push es
	push fs
	mov  es,VidSeg		; es = video segment
	mov  di,-1		; di = active list ptr
	mov  si,ddafrst 	; si = next list ptr
	mov  fs,ddas
@@FillLoop:
	cmp  di,-1
	jne  @@Active		; sono presenti dda attivi
	cmp  si,-1
	je   @@Done		; poligono terminato
	mov  dx,fs:[si+DDAY]	; Y-jump
@@Active:
	;
	; Attivazione di eventuali nuovi dda
	;
	cmp  si,-1
	je   @@NoNew
	cmp  dx,fs:[si+DDAY]	; Ordinata corretta ?
	jne  @@NoNew		; No, inutile indagare oltre
	mov  bx,fs:[si+DDANEXT]
	mov  fs:[si+DDANEXT],di ; Link alla lista attiva
	mov  di,si
	mov  si,bx
	jmp  @@Active
@@NoNew:
	;
	; Aggiornamento DDA attivi e memorizzazione estremi scanline
	;
	mov  bx,di		    ; bx = puntatore scorrimento lista dda
	mov  di,-1
	push si 		    ; usa si come registro di comodo
	mov  nx,0		    ; nx = numero di ascisse trovate ( x 4 )
@@DDAUpdate:
	cmp  bx,-1
	je   @@DrawScanLine
	mov  cx,fs:[bx+DDASXL]	    ; Aggiorna X
	add  fs:[bx+DDAXL],cx
	mov  cx,fs:[bx+DDASXH]
	adc  fs:[bx+DDAXH],cx

	cmp  SType,2
	jle  @@NoAB		    ; Risparmia i calcoli se non c'e' texture

	mov  cx,fs:[bx+DDASAL]	    ; Aggiorna A
	add  fs:[bx+DDAAL],cx
	mov  cx,fs:[bx+DDASAH]
	adc  fs:[bx+DDAAH],cx

	mov  cx,fs:[bx+DDASBL]	    ; Aggiorna B
	add  fs:[bx+DDABL],cx
	mov  cx,fs:[bx+DDASBH]
	adc  fs:[bx+DDABH],cx

@@NoAB:

	mov  cx,fs:[bx+DDAXH]	    ; Inserisce in lista ordinata per x cresc.
	mov  si,nx
	test si,si
	je   @@Found
@@XSearch:
	mov  ax,X0[si-4]
	cmp  cx,ax
	jge  @@Found
	mov  X0[si],ax
	mov  ax,X0[si-2]	    ; Copia puntatore al dda
	mov  X0[si+2],ax
	sub  si,4
	jne  @@XSearch
@@Found:
	mov  X0[si],cx		    ; Salva ascissa
	mov  X0[si+2],bx	    ; Salva puntatore al dda
	add  nx,4
	;
	; Aggiorna lista attiva
	;
	mov  ax,fs:[bx+DDANEXT]
	dec  word ptr fs:[bx+DDADY]
	je   @@DDADone
	mov  fs:[bx+DDANEXT],di 	; Reinserisce in lista attiva
	mov  di,bx
@@DDADone:
	mov  bx,ax
	jmp  @@DDAUpdate
@@DrawScanLine:
	;
	; Disegna scanline del poligono
	;
	push di 			; Salva registri importanti per Fill
	push dx

	cmp  SType,2			; Texture ?
	jle  @@Solid			; No, poligono solid
	;
	; Disegno di una scanline con texture mapping
	;
	cmp  dx,320			; Clipping X
	ja   @@Drawn

	mov  bx,dx			; imposta mask e offset
	mov  ah,byte ptr PMask[bx]
	shl  bx,1
	mov  di,word ptr HOffs[bx]
	add  di,basea
	mov  dx,03C4h
	mov  al,2
	out  dx,ax

	mov  si,nx			; si punta ai dda
@@Textured:
	sub  si,8			; retrocede di due dda
	jl   @@Drawn
	push si
	push di
	mov  bx,X0[si+6]		; bx = dda inferiore
	mov  si,X0[si+2]		; si = dda superiore

	mov  ax,fs:[si+DDAXH]		; legge ordinata iniziale

	mov  dx,fs:[bx+DDAXH]
	sub  dx,ax			; dx = dimensione teorica

	cmp  ax,0			; top clipping
	jge  @@TNoTop
	xor  ax,ax
@@TNoTop:
	mov  cx,fs:[bx+DDAXH]		; legge ordinata finale
	cmp  cx,200			; bottom clipping
	jle  @@TNoBot
	mov  cx,200
@@TNoBot:
	sub  cx,ax			; calcola differenza
	jle  @@NextDDA			; nulla da disegnare
	push cx

	mov  cx,dx			; cx = differenza originale

	mov  ax,fs:[si+DDAXH]		; rilegge ordinata iniziale

	mov  dx,80			; calcola l'indirizzo base
	mul  dx
	add  di,ax

;	 ; 80 = 16 + 64
;	 shl  ax,4
;	 add  di,ax
;	 shl  ax,2
;	 add  di,ax

	;
	; Calcolo velocita' lettura texture
	;

	and  ecx,00000FFFFh		; cx = denominatore (positivo)

	mov  dx,fs:[bx+DDAAL]		; imposta eax=(a1-a0)*65536/ecx
	sub  dx,fs:[si+DDAAL]
	mov  ax,fs:[bx+DDAAH]
	sbb  ax,fs:[si+DDAAH]
	shl  eax,16
	mov  ax,dx
	cdq
	idiv ecx
	mov  l1,eax			; salva risultato

	mov  dx,fs:[bx+DDABL]		; imposta eax=(b1-b0)*65536/ecx
	sub  dx,fs:[si+DDABL]
	mov  ax,fs:[bx+DDABH]
	sbb  ax,fs:[si+DDABH]
	shl  eax,16
	mov  ax,dx
	cdq
	idiv ecx
	mov  l2,eax			; salva risultato

	pop  cx

	;
	; Imposta loop di disegno:
	;
	;  Ŀ	XL    acc. texture X
	;   REG  MSW  MSB  LSB 	XH    texture X
	;  Ĵ	YL    acc. texture Y
	;   eax  SXL  ---  --- 	YH    texture Y
	;   ecx  XL   ---  CNT 	SXL   vel. texture X (low)
	;   edx  ---  ---  SYH 	SXH   vel. texture X (high)
	;   ebp  SYL     SXH    	SYL   vel. texture Y (low)
	;   ebx  YL   YH   XH  	SYH   vel. texture Y (high)
	;  	CNT   numero di pixel da disegnare
	;
	push bp
	shl  ecx,16
	mov  ax,word ptr fs:[si+DDAAL]
	shrd ecx,eax,16
	mov  dl,byte ptr l2[2]
	mov  bp,word ptr l1[2]
	shl  ebp,16
	mov  ax,word ptr l2[0]
	shrd ebp,eax,16
	mov  bl,fs:[si+DDAAH]
	mov  bh,fs:[si+DDABH]
	shl  ebx,16
	mov  ax,fs:[si+DDABL]
	shrd ebx,eax,16
	mov  ax,word ptr l1[0]
	shl  eax,16
	;
	; Disegno (!!!)
	;
	push si
	mov  si,fs:[si+DDAXH]		; rilegge ordinata iniziale
	cmp  si,0
	jge  @@NoTopClip
@@Inner1:
	add  ecx,eax
	adc  ebx,ebp
	adc  bh,dl
	add  di,80
	inc  si
	jne  @@Inner1
@@NoTopClip:
	pop  si
@@Inner:
	add  ecx,eax
	adc  ebx,ebp
	adc  bh,dl
	mov  dh,gs:[bx]
	add  dh,TxBase
	mov  es:[di],dh
	add  di,80
	dec  cx
	jne  @@Inner

	;
	; Ripristina
	;
	pop  bp
	xor  ecx,ecx

@@NextDDA:
	pop  di
	pop  si
	jmp  @@Textured

@@Solid:
	;
	; Disegno di una scanline solid
	;
	cmp  dx,200		    ; clipping -Y-
	ja   @@Drawn

	mov  ax,dx		    ; recupera y
	mov  cx,80
	mul  cx 		    ; calcola indirizzo di scanline
	add  ax,basea
	mov  dx,ax		    ; salva in dx

;	 ; 80 = 16 + 64
;	 shl  dx,4
;	 mov  ax,dx
;	 shl  dx,2
;	 add  dx,ax
;	 add  dx,basea

	mov  si,nx		    ; si punta ai dda
@@DrawLoop:
	sub  si,8		    ; Retrocede di due dda
	jl   @@Drawn
	mov  di,X0[si]		    ; ascissa iniziale
	cmp  di,0		    ; left clip
	jge  @@LeftOK
	xor  di,di
@@LeftOK:
	mov  bx,X0[si+4]	    ; ascissa finale
	cmp  bx,320		    ; right clip
	jle  @@RightOK
	mov  bx,320
@@RightOK:
	cmp  bx,di
	jle  @@DrawLoop 	    ; segmento vuoto

	dec  bx 		    ; punti -> pixel

	mov  al,byte ptr LMask[di]  ; maschera iniziale
	shl  di,1
	mov  di,word ptr HOffs[di]  ; offset iniziale

	mov  ah,byte ptr RMask[bx]  ; maschera finale
	shl  bx,1
	mov  cx,word ptr HOffs[bx]  ; offset finale

	sub  cx,di		    ; cx = numero di output necessari - 1
	jne  @@NotSingle
	and  al,ah		    ; un solo output
@@NotSingle:
	add  di,dx		    ; somma offset iniziale di scanline
	mov  bx,ax		    ; bx = registro mask
	push dx 		    ; dx usato per accedere a registri VGA
	mov  dx,03C4h

	mov  ah,bl		    ; imposta left mask
	mov  al,2
	out  dx,ax
	mov  ax,color
	stosb			    ; plot parte sinistra
	jcxz @@SegDone		    ; singolo output, segmento terminato

	dec  cx
	je   @@RightPlot	    ; Parte interna vuota

	mov  ax,00F02h		    ; full semibyte
	out  dx,ax
	mov  ax,color
	mov  ah,al

;	 push ax
;	 shl  eax,16
;	 pop  ax

;	 shr  cx,1
;	 jnc  @@Even
;	 stosb
;@@Even:
;	 jcxz @@RightPlot
;	 shr  cx,1
;	 jnc  @@Mul4
;	 stosw
;@@Mul4:
;	 rep  stosd		     ; plot parte interna

;	 ;
;	 ; Disegna la scanline con N long + 0/1 word + 0/1 byte
;	 ;
;	 shr  cx,1
;	 pushf
;	 shr  cx,1
;	 rep  stosd
;	 adc  cl,cl
;	 rep  stosw
;	 popf
;	 adc  cl,cl
;	 rep  stosb

	;
	; Disegna la scanline con N word + 0/1 byte
	;
	shr  cx,1
	rep  stosw
	adc  cl,cl
	rep  stosb

@@RightPlot:
	mov  al,2		    ; imposta right mask
	mov  ah,bh
	out  dx,ax
	mov  ax,color
	stosb			    ; plot parte destra
@@SegDone:
	pop  dx 		    ; recupera indirizzo base
	jmp  @@DrawLoop
@@Drawn:
	pop  dx 	    ; recupera registri
	pop  di
	pop  si 	    ; ... SI era stato salvato prima di DDAUpdate ...
	inc  dx 	    ; prossima Y
	jmp  @@FillLoop
@@Done:
	pop  fs
	pop  es
	ret
Fill	endp

lPts	dw   64 dup (0)

;
; Punto di un poligono
; AX = x, BX = y
; EAXH = a, EBXH = b
PolyPt	proc near
	push ecx
	push edx
	push esi
	push edi
	;
	; Memorizza il punto
	;
	mov  si,cv
	shl  si,2
	mov  lPts[si],ax
	mov  lPts[si+2],bx

	cmp  cv,0
	je   @@First

;	cmp  SType,0
;	je   @@NoFirst

	push eax	    ; Punto intermedio, unisce al precedente
	push ebx
	mov  ecx,dword ptr X0[8]
	mov  edx,dword ptr X0[12]
	call NewDDA
	pop  ebx
	pop  eax
	jmp  @@NoFirst
@@First:
	mov  dword ptr X0[0],eax       ; Salva coordinate primo punto
	mov  dword ptr X0[4],ebx
@@NoFirst:
	mov  dword ptr X0[8],eax       ; Salva coordinate punto precedente
	mov  dword ptr X0[12],ebx
	inc  cv
	dec  nv
	jne  @@Done

;	cmp  SType,0
;	je   @@DoFrame

	mov  ecx,dword ptr X0[0]       ; Unisce il primo all'ultimo punto
	mov  edx,dword ptr X0[4]
	xchg eax,ecx
	xchg ebx,edx
	call NewDDA
	cmp  ndda,0
	je   @@Done		       ; rimuovi poligono degenere
	mov  fs,ddas
	mov  si,asc		       ; recupera dda ascendente e discendente
	mov  bx,des
	cmp  SType,2		       ; se con texture considera il contrario
	jle  @@NoFLip
	xchg si,bx
@@NoFlip:
	cmp  back,0
	jne  @@DoIt		       ; non elimina back faces
	cmp  SType,0
	je   @@DoIt		       ; wireframe senza backfaces
	mov  ax,fs:[si+DDAXH]
	cmp  ax,fs:[bx+DDAXH]
	jl   @@Done		       ; sicuramente back
	jg   @@DoIt		       ; sicuramente front
	mov  eax,fs:[si+DDASXL]
	cmp  eax,fs:[bx+DDASXL]
	jle  @@Done		       ; back face
@@DoIt:
	call Fill		       ; riempi il poligono
	cmp  SType,2
	jge  @@Done		       ; solid o con texture, no frame
	cmp  back,0
	jne  @@Done		       ; dissolvenza, no frame
@@DoFrame:
	;
	; Frame del poligono in colore LINECOL
	;
;	call Rand		 ; anzi in colore random!
;	and  dx,15
;	mov  si,dx

	mov  si,LINECOL

	mov  di,cv
	shl  di,2
	mov  cx,lPts[0]
	mov  dx,lPts[2]
@@FrameLoop:
	sub  di,4
	mov  ax,cx
	mov  bx,dx
	mov  cx,lPts[di]
	mov  dx,lPts[di+2]
	push ax
	push bx
	push cx
	push dx
	push si
	call Line
	pop  si
	pop  dx
	pop  cx
	pop  bx
	pop  ax
	test di,di
	jne  @@FrameLoop
@@Done:
	pop  edi
	pop  esi
	pop  edx
	pop  ecx
	ret
PolyPt	endp

;
; Attesa inizio schermo
;
VRWait	proc near
	push dx
	push ax
	mov  dx,03DAh
@@Loop1:
	in   al,dx
	test al,8
	je   @@Loop1
@@Loop2:
	in   al,dx
	test al,8
	jne   @@Loop2
	pop  ax
	pop  dx
	ret
VRWait	endp

;
; Putpixel(ax=x, bx=y, cl=color)
;
PutPixel proc near
	;
	; Clipping
	;
	cmp  ax,320
	ja   @@Done
	cmp  bx,200
	ja   @@Done
	;
	; Salva i registri coinvolti
	;
	push ax
	push bx
	push dx
	push di
	push es

	push ax

	mov  ax,80
	mul  bx
	add  ax,basea
	mov  di,ax

;	 ; 80 = 16 + 64
;	 shl  bx,4
;	 mov  di,bx
;	 shl  bx,2
;	 add  di,bx
;	 add  di,basea

	pop  bx
	mov  ah,byte ptr PMask[bx]
	shl  bx,1
	add  di,word ptr HOffs[bx]
	mov  dx,03C4h
	mov  al,2
	out  dx,ax
	mov  es,VidSeg
	mov  es:[di],cl
	mov  ax,00F02h
	out  dx,ax

	pop  es
	pop  di
	pop  dx
	pop  bx
	pop  ax
@@Done:
	ret
PutPixel endp

;ldx	 dw  0
;ldy	 dw  0
;lix	 dw  0
;liy	 dw  0
;lm	 dw  0
;
;;
;; Line(ax,bx,cx,dx,si)
;;
;Line	 proc near
;	 push bp
;	 push ax	 ; Salva punto iniziale
;	 push bx
;	 sub  cx,ax	 ; Calcola DeltaX e IncX
;	 mov  lix,1
;	 jge  @@OKX
;	 neg  lix
;	 neg  cx
;@@OKX:
;	 mov  ldx,cx	 ; Calcola DeltaY e IncY
;	 sub  dx,bx
;	 mov  liy,1
;	 jge  @@OKY
;	 neg  liy
;	 neg  dx
;@@OKY:
;	 mov  ldy,dx
;	 cmp  cx,dx	 ; Calcola Max(DeltaX,DeltaY)
;	 jge  @@MAXX
;	 mov  cx,dx
;@@MAXX:
;	 mov  lm,cx
;	 mov  bp,cx	 ; BP = contatore pixel
;	 pop  bx	 ; Recupera punto iniziale
;	 pop  ax
;	 xchg cx,si	 ; si = X-Acc, cl = color
;	 shr  si,1
;	 mov  dx,si	 ; dx = Y-Acc
;@@Loop1:
;	 call PutPixel	 ; Disegna un pixel
;	 add  si,ldx	 ; Incremento (eventuale) x
;	 cmp  si,lm
;	 jb   @@NoX
;	 sub  si,lm
;	 add  ax,lix
;@@NoX:
;	 add  dx,ldy	 ; Incremento (eventuale) y
;	 cmp  dx,lm
;	 jb   @@NoY
;	 sub  dx,lm
;	 add  bx,liy
;@@NoY:
;	 dec  bp
;	 jge  @@Loop1
;	 pop  bp
;	 ret
;Line	 endp

;
; Line(ax,bx,cx,dx,si)
;
Line	proc near
	;
	; Test per null line
	;
	cmp  ax,cx
	jne  @@Ok1
	cmp  bx,dx
	jne  @@Ok1
	ret
@@Ok1:
	;
	; Salva i registri coinvolti
	;
	push es
	pushad

	;
	; Salva x0,y0 e il colore
	;
	push ax
	push bx
	push si

	;
	; Calcolo DeltaX e DeltaY e modifica del loop principale
	;
	mov  byte ptr [@@SignX+3],1	; *** NOT ROMABLE ***
	sub  cx,ax
	jge  @@XPos
	neg  cx
	neg  byte ptr [@@SignX+3]
@@XPos:
	mov  byte ptr [@@SignY+3],80	; *** NOT ROMABLE ***
	sub  dx,bx
	jge  @@YPos
	neg  dx
	neg  byte ptr [@@SignY+3]
@@YPos:
	cmp  cx,dx			; DeltaX > DeltaY ?
	jge  @@BigX			; Si, scala DeltaY
	;
	; DeltaY > DeltaX => scala DeltaX
	;
	push dx 			; salva pixel counter
	mov  bp,65535			; SpeedY = 0.99999
	mov  ax,cx
	mov  cx,dx
	mul  bp
	div  cx 			; Scalatura
	mov  si,ax			; Salva SpeedX
	jmp  @@Skip1
@@BigX:
	;
	; DeltaX > DelatY => scala DeltaY
	;
	push cx 			; salva pixel counter
	mov  si,65535			; SpeedX = 0.99999
	mov  ax,dx
	mul  si
	div  cx 			; Scalatura
	mov  bp,ax			; Salva SpeedX
@@Skip1:
	pop  ax 			; Imposta pixel counter
	shl  eax,16
	mov  es,VidSeg			; Segmento video (0xA000)

	pop  ax 			; recupera colore
	pop  di 			; recupera y0
	movsx edi,di

	imul edi,80			; calcola indirizzo fisico in edi

;	 ; 80 = 16 + 64
;	 shl  edi,4
;	 mov  ebx,edi
;	 shl  ebx,2
;	 add  edi,ebx

	xor  ebx,ebx
	pop  bx 			; recupera x0 in ebx
	mov  cx,08000h			; parte al centro del pixel
	mov  dx,cx

	;
	; Inizio del loop, a questo punto sono stati impostati
	;
	; es   = video segment
	; al   = colore
	; eaxh = pixel count
	; ebx  = x iniziale
	; edi  = y iniziale * 80
	; cx   = parte frazionaria di x
	; si   = velocita' frazionaria di x (con segno)
	; dx   = parte frazionaria di y
	; bp   = velocita' frazionaria di y (positiva)
@@Loop:
	cmp  ebx,320	    ; clipping x
	jae  @@Ko
	cmp  edi,200*80     ; clipping y
	jae  @@Ko

	;
	; Plot del pixel
	; (in modo 0x13 normale sarebbe solo "mov  es:[bx+di],al")
	;
	push bx 		    ; salva x
	mov  ah,byte ptr PMask[bx]  ; legge mask
	shr  bx,2		    ; imposta addr fisico
	add  bx,basea
	push dx 		    ; salva dx
	push ax 		    ; salva colore
	mov  dx,03C4h		    ; imposta mask di accesso
	mov  al,02h
	out  dx,ax
	pop  ax 		    ; recupera colore
	mov  es:[di+bx],al	    ; putpixel
	pop  dx 		    ; recupera dx
	pop  bx 		    ; recupera bx
@@Ko:
	add  cx,si
	jnc  @@Offx
@@Signx:
	add  ebx,0	    ; segno velocita' X
@@Offx:
	add  dx,bp
	jnc  @@Offy
@@Signy:
	add  edi,80	    ; (segno velocita' Y)*80
@@Offy:
	sub  eax,65536
	jg   @@Loop

	;
	; Finito!!!!
	;
	mov  dx,03D4h
	mov  ax,0F02h
	out  dx,ax
	popad
	pop es
	ret
Line	endp

;
; Disegna una scritta (offset in SI) partendo da (ax,bx) in colore cl
;
Text	proc near
	push di
	push es

	mov  es,FontSeg
	mov  ch,txcol1
@@Loop1:
	mov  di,[si]
	and  di,00FFh
	je   @@Done	    ; Null = end of string
	cmp  di,'@'         ; jmp code ?
	jne  @@NoJmp
	add  ax,256
	jmp  @@NextChar
@@NoJmp:
	cmp  di,'#'
	jne  @@NoColor
	xor  cl,ch
	jmp  @@NextChar
@@NoColor:
	cmp  ax,-8
	jle  @@NextChar1
	shl  di,3	    ; find char offset
	add  di,0FA6Eh
	mov  dx,00880h	    ; inizializza pixel mask in DL, row count in DH
@@Loop2:
	test dl,es:[di]
	je   @@Skip
	call PutPixel
@@Skip:
	add  ax,1	    ; prossima x
	shr  dl,1	    ; shift bit mask
	jne  @@Loop2
	sub  ax,8	    ; riporta x a sinistra
	mov  dl,080h	    ; reset bitmask
	inc  di 	    ; passa alla prossima scanline
	inc  bx
	dec  dh 	    ; sino a fine carattere
	jne  @@Loop2
	sub  bx,8	    ; riporta in alto
@@NextChar1:
	add  ax,8	    ; sposta al prossimo carattere
@@NextChar:
	cmp  ax,320
	jge  @@Done
	inc  si
	jmp  @@Loop1
@@Done:
	pop  es
	pop  di
	ret
Text	endp

;
;     /~~~~~~~~~~/|	/~~~~~~~~/\
;   /__________/  |   /________/    \
;  |:::::::::::|  |  |::::::::::\    /.
;  |:::::::::::| /   |::::::::::::\/  |
;  "~~~~~~/::::/\    |:::|~~|~\::::|  |
;	/::::/	  \  |:::|  |  |:::|  |
;      |:::::\	  /| |:::|  |  |:::|  |
;      "~~~\:::\/  | |:::|  |  |:::|  |
;     /~~~~~|:::|  / |:::|  /~~|:::|  /
;   /______/::::|/   |:::|/___/::::|/
;  |:::::::::::/     |::::::::::::/
;  |:::::::::/	     |::::::::::/
;  "~~~~~~~~'        "~~~~~~~~~'
;
AA	dw   0		; angolo asse x
BB	dw   0		; angolo asse y
CC	dw   0		; angolo asse z

AA0	dw   0		; angolo asse x (aggiornato da Int8)
BB0	dw   0		; angolo asse y
CC0	dw   0		; angolo asse z

XC	dw   0		; traslazione X
YC	dw   0		; traslazione Y
ZC	dw   500	; traslazione Z

ZO	dw   -232	; z osservatore

X	dw   0		; X punto in considerazione
Y	dw   0		; Y punto in considerazione
Z	dw   0		; Z punto in considerazione

;NNX	 dw   0 	 ; X normale in considerazione
;NNY	 dw   0 	 ; Y normale in considerazione
;NNZ	 dw   0 	 ; Z normale in considerazione

npts	dw   0		; numero punti
npoly	dw   0		; numero poligoni

;;
;; Normalizzazione di un vettore a 127
;;
;Norm	 proc near
;	 push si
;	 mov  NNX,ax
;	 mov  NNY,bx
;	 mov  NNZ,cx
;
;	 imul ax	     ; X*127
;	 mov  si,ax
;
;	 mov  ax,bx	     ; Y*127
;	 imul bx
;	 add  si,ax
;
;	 mov  ax,cx	     ; Z*127
;	 imul cx
;	 add  si,ax
;
;	 ;
;	 ; Estrazione radice quadrata di si
;	 ;
;	 ; X  = 0.5 N,	X   = 0.5 ( X + N/X )
;	 ;  0		 i+1	     i	   i
;	 ;
;	 ; Stop se | X	- X    | < 2
;	 ;	      i    i+1
;	 ;
;	 mov  ax,si
;	 shr  ax,8	     ; ax = X0
;	 je   @@Zero
;@@Loop:
;	 mov  bx,ax	     ; salva Xi
;	 mov  ax,si	     ; imposta numeratore
;	 mov  dx,0
;	 idiv bx
;	 add  ax,bx
;	 inc  ax	     ; arrotonda prima della divisione per 2
;	 sar  ax,1
;	 sub  bx,ax	     ; Confronta X(i+1) con X(i)
;	 cmp  bx,2
;	 jge  @@Loop
;	 cmp  bx,-2
;	 jle  @@Loop
;
;	 mov  si,ax	     ; si = denominatore
;
;	 mov  ax,NNX	     ; X = X/sqrt(N)
;	 cwd		     ; moltiplica numeratore per 127 (precond.)
;	 shld dx,ax,7
;	 shl  ax,7
;	 idiv si
;	 push ax	     ; salva normalizzato
;
;	 mov  ax,NNY	     ; Y = Y/sqrt(N)
;	 cwd		     ; moltiplica numeratore per 127 (precond.)
;	 shld dx,ax,7
;	 shl  ax,7
;	 idiv si
;	 push ax	     ; salva normalizzato
;
;	 mov  ax,NNZ	     ; Z = Z/sqrt(N)
;	 cwd		     ; moltiplica numeratore per 127 (precond.)
;	 shld dx,ax,7
;	 shl  ax,7
;	 idiv si
;
;	 mov  cx,ax	     ; salva normalizzato
;	 pop  bx	     ; recupera Y
;	 pop  ax	     ; recupera X
;@@Zero:
;	 pop  si
;	 ret
;Norm	 endp

;
; Rotazione di un vettore 3d degli angoli AA,BB,CC attorno agli assi X,Y e Z
;
Rot	proc near
	push dx
	push si
	push di
	push es
	;
	; Salva per comodita'
	;
	mov  X,ax
	mov  Y,bx
	mov  Z,cx
	mov  es,sine
	;
	; Rotazione asse X
	; y'=y cos(aa) + z sin(aa), z'= z cos(aa) - y sin(aa)
	;
	mov  si,aa
	mov  di,Y	; salva y
	mov  ax,di
	imul word ptr es:[si+512]
	shrd ax,dx,15
	mov  Y,ax
	mov  ax,Z
	imul word ptr es:[si]
	shrd ax,dx,15
	add  Y,ax
	mov  ax,Z
	imul word ptr es:[si+512]
	shrd ax,dx,15
	mov  Z,ax
	mov  ax,di
	imul word ptr es:[si]
	shrd ax,dx,15
	sub  Z,ax

	;
	; Rotazione asse Y
	; x'=x cos(bb) + z sin(bb), z'= z cos(bb) - x sin(bb)
	;
	mov  si,bb
	mov  di,X	; salva x
	mov  ax,di
	imul word ptr es:[si+512]
	shrd ax,dx,15
	mov  X,ax
	mov  ax,Z
	imul word ptr es:[si]
	shrd ax,dx,15
	add  X,ax
	mov  ax,Z
	imul word ptr es:[si+512]
	shrd ax,dx,15
	mov  Z,ax
	mov  ax,di
	imul word ptr es:[si]
	shrd ax,dx,15
	sub  Z,ax

	;
	; Rotazione asse Z
	; x'=x cos(cc) + y sin(cc), y'= y cos(cc) - x sin(cc)
	;
	mov  si,cc
	mov  di,X	; salva x
	mov  ax,di
	imul word ptr es:[si+512]
	shrd ax,dx,15
	mov  X,ax
	mov  ax,Y
	imul word ptr es:[si]
	shrd ax,dx,15
	add  X,ax
	mov  ax,Y
	imul word ptr es:[si+512]
	shrd ax,dx,15
	mov  Y,ax
	mov  ax,di
	imul word ptr es:[si]
	shrd ax,dx,15
	sub  Y,ax

	mov  ax,X
	mov  bx,Y
	mov  cx,Z
	pop  es
	pop  di
	pop  si
	pop  dx
	ret
Rot	endp

;
; Map di un punto 3d dopo la rotazione e la traslazione di XC,YC,ZC
; (ax=x, bx=y, cx=z) -> (ax=xs, bx=ys, cx=zsort)
;
Map	proc near
	call Rot
	add  ax,XC
	add  bx,YC
	add  cx,ZC		; Map entra in Map1 ...
Map	endp
;
; Map di un punto 3d
; (ax=x, bx=y, cx=z) -> (ax=xs, bx=ys)
;
Map1	proc near
	push dx

	sub  cx,ZO
	imul ZO
	idiv cx
	mov  X,ax

	mov  ax,bx
	imul ZO
	idiv cx

	mov  bx,100
	sub  bx,ax
	mov  ax,160
	sub  ax,X
	add  cx,ZO

	pop  dx
	ret
Map1	endp

R1	dw   126	; raggio minore
R2	dw   192	; raggio maggiore

torm	dw   8		; numero di meridiani
torn	dw   6		; numero di paralleli

; variabili di comodo

torm1	dw   0		; numero di paralleli - 1
torn1	dw   0		; numero di paralleli - 1
torn30	dw   0		; torn * 30
tt30	dw   0		; torm * torn * 30

tormi	dw   0		; distanza angolare meridiani
torni	dw   0		; distanza angolare paralleli

torai	dw   0		; incremento texture - A -
torbi	dw   0		; incremento texture - B -

cM	dw   0		; contatore meridiani
cN	dw   0		; contatore paralleli

K30	dw   30 	; costante per mul

;
; Costruzione di un toro
;
Torus	proc near
	;
	; Test di inutilita' ricalcolo
	;
	cmp  TorFlag,0
	jne  @@DoIt
	ret
@@DoIt:
	mov  TorFlag,0
	;
	; Calcolo costanti di comodo
	;
	mov  ax,1024
	xor  dx,dx
	div  torm
	shl  ax,1
	mov  tormi,ax
	mov  ax,1024
	xor  dx,dx
	div  torn
	shl  ax,1
	mov  torni,ax

	mov  ax,1024
	xor  dx,dx
	idiv torn
	mov  torai,ax

	mov  ax,2048
	xor  dx,dx
	idiv torm
	mov  torbi,ax

	mov  ax,torn
	dec  ax
	mov  torn1,ax
	mov  ax,torm
	dec  ax
	mov  torm1,ax
	mov  ax,torn
	mul  K30
	mov  torn30,ax
	mul  torm
	mov  tt30,ax

	;
	; Passo 1: calcolo vertici e normali
	;
	xor  di,di		    ; puntatore al vertice definito
	mov  npts,di
	mov  npoly,di
	mov  es,sine
	mov  aa,di
	mov  cc,0

	mov  si,di
	mov  bb,di

	mov  ax,torm
	mov  cm,ax
	mov  ax,torn
	mov  cn,ax

@@Loop1:
	xor  dx,dx		    ; 0 = punto, 1 = normale
@@Loop2:
	push dx
	mov  ax,es:[si] 	    ; sin(t)
	imul r1 		    ; *r1
	shrd ax,dx,15
	mov  bx,ax		    ; -> Y
	mov  ax,es:[si+512]	    ; cos(t)
	imul r1 		    ; *r1
	shrd ax,dx,15
	pop  dx
	test dx,dx
	jne  @@Normal
	add  ax,r2		    ; +r2 -> X
@@Normal:
	xor  cx,cx		    ; 0 -> Z
	call Rot		    ; ruota attorno all'asse Y
	mov  word ptr pts[di],ax    ; salva le coordinate calcolate
	mov  word ptr pts[di+2],bx
	mov  word ptr pts[di+4],cx
	add  di,6
	inc  dx 		    ; calcola anche la normale
	cmp  dx,2
	jne  @@Loop2
	inc  npts
	add  di,18		    ; salta xs,ys,zs,nxs,nys,nzs,rxs,rys,rzs

	add  si,torni		    ; incrementa l'angolo minore
	dec  cn
	jne  @@Loop1
	mov  ax,torn
	mov  cn,ax
	xor  si,si

	mov  ax,tormi		    ; incrementa l'angolo maggiore
	add  bb,ax
	dec  cm
	jne  @@Loop1
	mov  bb,0

	;
	; Passo 2: definizione facce
	;
	mov  ax,cs
	mov  es,ax
	mov  di,offset fpt
	xor  bx,bx				; bx = puntatore meridiani
	xor  cx,cx				; cx = puntatore paralleli
	xor  si,si				; si = texture 'A'
	xor  dx,dx				; dx = texture 'B'
@@Loop3:
	inc  npoly
	mov  ax,4
	stosw					; numero vertici
	mov  al,cl				; salva id poligono
	mov  ah,bl
	stosw					; colore

	push dx

	mov  ax,torn
	mul  cx
	add  ax,bx

	mul  K30				; 1 vertice = 30 bytes

	pop  dx

	stosw					; primo punto
	mov  word ptr es:[di],si		; texture 0,0
	mov  word ptr es:[di+2],dx
	add  di,4
	cmp  bx,torn1
	jne  @@NoZ
	sub  ax,torn30
@@NoZ:
	add  si,torai
	add  ax,30
	stosw					; secondo punto
	mov  word ptr es:[di],si		; texture 255,0
	mov  word ptr es:[di+2],dx
	add  di,4
	cmp  cx,torm1
	jne  @@NoZ1
	sub  ax,tt30
@@NoZ1:
	add  ax,torn30
	add  dx,torbi
	stosw					; terzo punto
	mov  word ptr es:[di],si		; texture 255,255
	mov  word ptr es:[di+2],dx
	add  di,4
	cmp  bx,torn1
	jne  @@NoZ3
	add  ax,torn30
@@NoZ3:
	sub  ax,30
	sub  si,torai
	stosw					; quarto punto
	mov  word ptr es:[di],si		; texture 0,255
	mov  word ptr es:[di+2],dx
	add  di,4

	sub  dx,torbi
	add  si,torai
	add  bx,1
	cmp  bx,torn
	jne  @@Loop3
	xor  si,si
	add  dx,torbi
	xor  bx,bx
	add  cx,1
	cmp  cx,torm
	jne  @@Loop3

	ret
Torus	endp

xmed	dw 0
ymed	dw 0
medcnt	dw 0

;
; Modello di illuminazione
;
Light	proc near
	;
	; Calcola modello di illuminazione
	;
	xor  di,di
	mov  es,lmod
	mov  fs,phong
@@Light:
	mov  ax,di	    ; calcola (u-128)
	and  ax,255
	sub  ax,128-32
	imul ax
	mov  bx,dx
	mov  cx,ax

	mov  ax,di	    ; calcola (v-128)
	shr  ax,8
	sub  ax,128-32
	imul ax
	add  ax,cx	    ; somma a valore precedente
	adc  bx,dx
	shld bx,ax,8

	push bx
	mov  ax,31	    ; calcola palette Gouraud
	shr  bx,2
	sub  ax,bx
	cmp  ax,0
	jge  @@OkL
	xor  ax,ax
@@OkL:
	mov  es:[di],al
	pop  bx 	    ; calcola palette Phong
	sub  bx,63
	neg  bx
	mov  ax,bx
	mul  ax
	shr  ax,8
	add  ax,15
	jge  @@OkL1
	xor  ax,ax
@@OkL1:
	mov  fs:[di],al
	inc  di
	jne  @@Light
	ret
Light	endp

;
; Disegna l'intero oggetto
;
Draw	proc near
	cmp  npts,0
	je   @@Nothing
	cmp  npoly,0
	jne  @@Something
@@Nothing:
	ret
@@Something:
	;
	; Mapping dei punti
	;

	mov  ax,aa
	mov  bx,bb
	mov  cx,cc
	mov  aa,bx
	mov  bb,cx
	mov  cc,ax

	mov  ax,100
	mov  bx,100
	mov  cx,100
	call Rot
	add  cx,1300
	mov  XC,ax
	mov  YC,bx
	mov  ZC,cx

	mov  ax,aa
	mov  bx,bb
	mov  cx,cc
	mov  aa,cx
	mov  bb,ax
	mov  cc,bx

	xor  si,si
	mov  dx,npts
@@Loop1:
	;
	; Rototraslazione vertice e proiezione 3d -> 2d
	;
	mov  ax,word ptr pts[si]
	mov  bx,word ptr pts[si+2]
	mov  cx,word ptr pts[si+4]
	call Map
	mov  word ptr pts[si+12],ax
	mov  word ptr pts[si+14],bx
	mov  word ptr pts[si+16],cx

	;
	; Rotazione normale
	;
	mov  ax,word ptr pts[si+6]
	mov  bx,word ptr pts[si+8]
	mov  cx,word ptr pts[si+10]

	call Rot

	mov  word ptr pts[si+18],ax
	mov  word ptr pts[si+20],bx
	mov  word ptr pts[si+22],cx

@@Chrome:
	;
	; /%%%%%%%%\ /%%\   /%%\ /%%%%%%%\   /%%%%%%%%%\ /%\	 /%\ /%%%%%%%%\
	; &&&&&&&&&& &&&&   &&&& &&&&&&&&&&\ &&&&&&&&&&& &&&&\ /&&&& &&&&&&&&&&
	; #########/ ####   #### ########### ########### ########### #########/
	; ####	     ####   #### ####	#### ####   #### ########### ####
	; @@@@	     @@@@@@@@@@@ @@@@  /@@@/ @@@@   @@@@ @@@@@@@@@@@ @@@@@@@@\
	; ....	     ........... ......../   ....   .... .... . .... ......../
	; ::::	     ::::   :::: ::::::::\   ::::   :::: ::::	:::: ::::
	; %%%%%%%%%\ %%%%   %%%% %%%%  \%%%\ %%%%%%%%%%% %%%%	%%%% %%%%%%%%%\
	; ########## ####   #### ####	#### ########### ####	#### ##########
	; \@@@@@@@@/ \@@/   \@@/ \@@/	\@@/ \@@@@@@@@@/ \@@/	\@@/ \@@@@@@@@/
	;

	;
	; Calcola direzione riflessa
	;
	;	 r=i-2(ni)n
	;
	push dx 			; salva contatore punti

	mov  X,ax			; salva normale ruotata
	mov  Y,bx
	mov  Z,cx

	;
	; Calcola 2(ni)
	;
	mov  ax,word ptr pts[si+12]	; Calcola (XS-XO)
	sub  ax,160
	push ax
	imul X				; moltiplica per NX
	shrd ax,dx,7			; /128 (approx. i/2 )
	mov  di,ax			; salva totale parziale

	mov  ax,word ptr pts[si+14]	; Calcola (YS-YO)
	sub  ax,100
	push ax
	imul Y				; moltiplica per NY
	shrd ax,dx,7			; /128
	add  di,ax

	xor  ax,ax			; Calcola (ZS-YO)
	sub  ax,ZO
	push ax
	imul Z				; moltiplica per NZ
	shrd ax,dx,7			; /128
	add  di,ax

	;
	; Calcola la direzione riflessa = i-(si/128)n
	;
	mov  ax,Z			; nz
	imul di
	shrd ax,dx,7			; scala risultato
	pop  Z				; recupera iz
	sar  Z,2			; scala a | | = 127
	sub  Z,ax
	mov  ax,Y			; ny
	imul di
	shrd ax,dx,7			; scala risultato
	pop  Y				; recupera iy
	sar  Y,2			; scala a | | = 127
	sub  Y,ax
	mov  ax,X			; nx
	imul di
	shrd ax,dx,7			; scala risultato
	pop  X				; recupera ix
	sar  X,2			; scala a | | = 127
	sub  X,ax

	pop  dx 			; recupera contatore

	;
	; Recupera la risultante
	;
	mov  ax,X
	mov  bx,Y
	mov  cx,Z

;@@Chrome:
;	 ;
;	 ; /%%%%%%%%\ /%%\   /%%\ /%%%%%%%\   /%%%%%%%%%\ /%\	  /%\ /%%%%%%%%\
;	 ; &&&&&&&&&& &&&&   &&&& &&&&&&&&&&\ &&&&&&&&&&& &&&&\ /&&&& &&&&&&&&&&
;	 ; #########/ ####   #### ########### ########### ########### #########/
;	 ; ####       ####   #### ####	 #### ####   #### ########### ####
;	 ; @@@@       @@@@@@@@@@@ @@@@	/@@@/ @@@@   @@@@ @@@@@@@@@@@ @@@@@@@@\
;	 ; ....       ........... ......../   ....   .... .... . .... ......../
;	 ; ::::       ::::   :::: ::::::::\   ::::   :::: ::::	 :::: ::::
;	 ; %%%%%%%%%\ %%%%   %%%% %%%%	\%%%\ %%%%%%%%%%% %%%%	 %%%% %%%%%%%%%\
;	 ; ########## ####   #### ####	 #### ########### ####	 #### ##########
;	 ; \@@@@@@@@/ \@@/   \@@/ \@@/	 \@@/ \@@@@@@@@@/ \@@/	 \@@/ \@@@@@@@@/
;	 ;
;
;	 ;
;	 ; Calcola direzione riflessa
;	 ;
;	 ;	  r=i-2(ni)n
;	 ;
;	 push dx			 ; salva contatore punti
;
;	 mov  X,ax			 ; salva normale ruotata
;	 mov  Y,bx
;	 mov  Z,cx
;
;	 ;
;	 ; Calcola 2(ni)
;	 ;
;	 mov  ax,word ptr pts[si+12]	 ; Calcola (XS-XO)
;	 sub  ax,160
;	 mov  bx,word ptr pts[si+14]	 ; Calcola (YS-YO)
;	 sub  bx,100
;	 mov  ax,0			 ; Calcola (ZS-ZO)
;	 sub  ax,ZO
;	 call Norm
;
;	 push ax			 ; Salva direzione incidente
;	 push bx
;	 push cx
;
;	 imul X 			 ; moltiplica per NX
;	 shrd ax,dx,6			 ; /128 (postcond.) * 2
;	 mov  di,ax			 ; salva totale parziale
;
;	 mov  ax,bx
;	 imul Y 			 ; moltiplica per NY
;	 shrd ax,dx,6			 ; /128 * 2
;	 add  di,ax
;
;	 mov  ax,cx
;	 imul Z 			 ; moltiplica per NZ
;	 shrd ax,dx,6			 ; /128 * 2
;	 add  di,ax
;
;	 ;
;	 ; Calcola la direzione riflessa = i-(si/128)n
;	 ;
;	 mov  ax,Z			 ; nz
;	 imul di
;	 shrd ax,dx,7			 ; scala risultato
;	 pop  Z 			 ; recupera iz
;	 sub  Z,ax
;	 mov  ax,Y			 ; ny
;	 imul di
;	 shrd ax,dx,7			 ; scala risultato
;	 pop  Y 			 ; recupera iy
;	 sub  Y,ax
;	 mov  ax,X			 ; nx
;	 imul di
;	 shrd ax,dx,7			 ; scala risultato
;	 pop  X 			 ; recupera ix
;	 sub  X,ax
;
;	 pop  dx			 ; recupera contatore
;
;	 ;
;	 ; Recupera la risultante
;	 ;
;	 mov  ax,X
;	 mov  bx,Y
;	 mov  cx,Z

	mov  word ptr pts[si+24],ax
	mov  word ptr pts[si+26],bx
	mov  word ptr pts[si+28],cx

	add  si,30
	dec  dx
	jne  @@Loop1

	;
	; Sort (Shell-Metzner)
	;

	;
	; Passo 1: Costruzione vettore di appoggio per ordinamento
	;
	xor  di,di			 ; di = indirizzo poligono
	xor  si,si			 ; si = numero poligono * 4
	mov  dx,npoly
@@SLoop1:
	mov  word ptr polys[si],di	 ; salva l'indirizzo poligono
	mov  cx,word ptr fpt[di]	 ; cx = numero vertici
	xor  ax,ax			 ; ax = massima Z
	add  di,4
@@SLoop2:
	mov  bx,word ptr fpt[di]	 ; bx = indirizzo punto
	cmp  word ptr pts[bx+16],ax
	jle  @@NoMax
	mov  ax,word ptr pts[bx+16]
@@NoMax:
	add  di,6
	loop @@SLoop2
	mov  word ptr polys[si+2],ax	 ; salva Z max
	add  si,4
	dec  dx
	jne  @@SLoop1

	;
	; Passo 2: sort per Z crescente
	; (crescente perche' i poligoni saranno poi letti dal vettore
	;  partendo dall'ultimo)
	;
	mov  bx,npoly			  ; bx = delta
@@SLoop3:
	shr  bx,1
	je   @@Sorted
	shl  bx,2			  ; bx = offset
	xor  si,si			  ; si = puntatore principale
@@SLoop4:
	mov  di,si			  ; di = puntatore secondario
@@SLoop5:
	mov  eax,dword ptr polys[di]	  ; carica z1 & p1
	mov  ecx,dword ptr polys[di+bx]   ; carica z2 & p2
	cmp  eax,ecx			  ; test
	jle  @@NoSwap
	mov  dword ptr polys[di],ecx	  ; scambia i poligoni
	mov  dword ptr polys[di+bx],eax
	sub  di,bx			  ; prosegue il galleggiamento
	jge  @@SLoop5
@@NoSwap:
	add  si,4			  ; incrementa ptr principale
	mov  ax,si			  ; confronta con npoly-delta
	add  ax,bx
	shr  ax,2			  ; (confronto in numero, non offset)
	cmp  ax,npoly
	jne  @@SLoop4
	shr  bx,2			  ; riporta il delta a numero
	jmp  @@SLoop3
@@Sorted:
	;
	; Disegno
	;
	mov  si,npoly			  ; si = ptr poligono
	shl  si,2
@@Loop2:
	sub  si,4

	mov  di,word ptr polys[si]	  ; di = indirizzo poligono

	;
	; Calcola lo stile del poligono
	;
	mov  ax,phase
	test ax,ax
	je   @@Store
	sub  ax,1
	cmp  ax,6
	jb   @@Store
	mov  ax,word ptr fpt[di+2]	  ; coordinate (i,j) del poligono
	shr  ax,2
	and  ax,7
	cmp  ax,6
	jb   @@Store
	sub  ax,6
@@Store:
	mov  SType,ax

	;
	; Calcola colore e colore base
	;
	mov  ax,word ptr fpt[di+2]	  ; coordinate (i,j) del poligono
	add  al,ah
	and  ax,15
	mov  Color,ax
	shl  al,5			  ; calcola colore base
	jne  @@NoBlack
	mov  al,64
@@NoBlack:
	mov  TxBase,al

	mov  ax,word ptr fpt[di]	  ; ax = numero punti
	add  di,4
	mov  dx,ax
	call NewPoly
	mov  xmed,0			  ; azzera totali per media normali
	mov  ymed,0
	mov  medcnt,0
@@Loop3:
	;
	; Assegnazione a,b
	;
	cmp  SType,2
	jle  @@Solid			  ; Nessuna coordinata

	mov  bx,18			  ; Normale
	mov  gs,lmod			  ; Modello illuminazione Gouraud

	cmp  SType,5			  ; Phong ?
	jne  @@Gouraud			  ; No, usa la normale
	add  bx,6			  ; Normale riflessa
	mov  gs,phong			  ; Modello Phong
@@Gouraud:
	add  bx,word ptr fpt[di]	  ; indirizzo punto

	mov  ax,word ptr pts[bx]
	add  ax,128
	mov  bx,word ptr pts[bx+2]
	add  bx,128

	cmp  SType,3			  ; Texture ?
	jne  @@NoText			  ; No, non calcolare la media

	;
	; Poligono con texture
	;
	add  xmed,ax			   ; somma per normale media
	add  ymed,ax
	inc  medcnt
	cmp  dx,1			   ; Ultimo punto ?
	jne  @@NoLast
	push dx 			   ; calcola media normali
	mov  ax,xmed
	xor  dx,dx
	div  medcnt
	mov  bl,al
	mov  ax,ymed
	xor  dx,dx
	div  medcnt
	mov  bh,al
	mov  gs,Lmod			   ; Usa Gouraud
	mov  al,gs:[bx] 		   ; legge luminosita'
	shr  al,1			   ; scala a 0..15
	add  al,7*32			   ; somma colore bianco
	mov  TxBase,al
	;add  TxBase,al 		    ; somma al colore base
	pop  dx
@@NoLast:
	mov  ax,word ptr fpt[di+2]	   ; Lettura texture point
	mov  bx,word ptr fpt[di+4]
	mov  gs,Plasma
@@NoText:
	shl  eax,16
	shl  ebx,16
@@Solid:
	mov  bx,word ptr fpt[di]
	mov  ax,word ptr pts[bx+12]	  ; X schermo
	mov  bx,word ptr pts[bx+14]	  ; Y schermo
	call PolyPt
	add  di,6
	dec  dx
	jne  @@Loop3
	test si,si
	jne  @@Loop2

	ret
Draw	endp


;
; Page flipping: visualizza la pagina corrente e predispone una nuova pagina
;		 copiando il background.
;
; viene anche fatta scorrere una scritta sul fondo dello schermo e sono
; gestiti l'inizio e la fine del programma
;
Flip	proc near
;	 inc  nFrame
	push ax
	push bx
	push cx
	push dx
	push si
	push di
	push ds
	push es
	push bp

	mov  dx,03Dah
@@Wait:
	in   al,dx
	test al,8
	je   @@Wait

	cmp  phase,0
	je   @@Star
	cmp  phase,PHASES-1
	jne  @@NoStar
@@Star:
	;
	; Cancella tutto tranne una stella rotante
	;
	mov  si,AA		; si = angolo iniziale
	mov  es,sine
	mov  di,StarRad 	; di = Raggio minore
	mov  bp,di		; bp = Raggio maggiore + raggio minore
	shl  bp,1
	add  bp,di
	mov  ax,10
	mov  Color,0
	mov  SType,2
	call NewPoly
	xor  ax,ax		; Bordo sinistro
	xor  bx,bx
	xor  cx,cx
	mov  dx,200
	call NewDDA
	mov  ax,320		; Bordo destro
	mov  bx,200
	mov  cx,ax
	xor  dx,dx
	call NewDDA
	mov  dx,10
	inc  back
@@Star1:
	push dx 			; Salva contatore punti
	mov  ax,di			; calcola Y
	imul word ptr es:[si]
	mov  bx,100
	sub  bx,dx
	mov  ax,di			; calcola X
	imul word ptr es:[si+512]
	mov  ax,dx
	add  ax,160
	call PolyPt			; assegna il punto
	sub  di,bp			; commuta il raggio
	neg  di
	add  si,204			; incrementa l'angolo
	and  si,2047
	pop  dx
	dec  dx
	jne  @@Star1
	dec  back

@@NoStar:

	; Disegna scritta
	mov  ax,banx
	mov  bx,190
	mov  si,offset banner
	mov  cl,TXCOL0
	call Text

	;
	; Imposta solo high byte pagina corrente
	;
;	 mov  dx,03DAh
;@@L1:
;	 in   al,dx
;	 test al,8
;	 je   @@L1
;@@L2:
;	 in   al,dx
;	 test al,8
;	 jne  @@L2

	mov  dx,03D4h
	mov  ax,basea
	mov  al,12
	out  dx,ax

	;
	; Sceglie nuova pagina di lavoro
	;
	add  basea,16384	; passa alla prossima pagina
;	 cmp  basea,16384*3	 ; pagina 4 ?
;	 jne  @@Ok
;	 mov  basea,0
;@@Ok:

;	 ;
;	 ; Disegna la texture come sfondo
;	 ;
;	 mov  ax,4
;	 mov  color,-1
;	 call NewPoly
;	 mov  eax,0
;	 mov  ebx,0
;	 call PolyPt
;	 mov  eax,001400140h
;	 mov  ebx,0
;	 call PolyPt
;	 mov  eax,001400140h
;	 mov  ebx,000FF00C8h
;	 call PolyPt
;	 mov  eax,0
;	 mov  ebx,000FF00C8h
;	 call PolyPt

;	 mov  dx,03C4h
;	 mov  ax,0F02h
;	 out  dx,ax
;	 mov  eax,060606060h
;	 mov  di,basea
;	 mov  bx,25
;	 mov  es,VidSeg
;@@Loop1:
;	 mov  cx,80
;	 rep  stosd
;	 add  eax,01010101h
;	 dec  bx
;	 jne  @@Loop1
;	 mov  eax,0CBCBCBCBh
;	 mov  bx,20
;@@Loop2:
;	 mov  cx,20*5
;	 rep  stosd
;	 add  eax,01010101h
;	 dec  bx
;	 jne  @@Loop2

	 mov  dx,03C4h		 ; Zap
	 mov  ax,0F02h
	 out  dx,ax
	 mov  eax,BKGND32
	 mov  cx,4000
	 mov  es,VidSeg
	 mov  di,basea
	 rep  stosd

;	 ; Imposta indirizzi sorgente e destinazione
;	 mov  di,basea
;	 mov  si,16384*3
;	 mov  es,VidSeg
;	 mov  ds,VidSeg
;
;	 ; Imposta write mode 1
;	 mov  dx,03C4h
;	 mov  ax,00F02h
;	 out  dx,ax
;	 mov  dx,03CEh
;	 mov  al,005h
;	 out  dx,al
;	 inc  dx
;	 in   al,dx
;	 and  al,0FCh
;	 or   al,001h
;	 out  dx,al
;
;	 mov  cx,16000		 ; Copia per byte
;	 rep  movsb		 ; (per word o doubleword non e' corretto!)
;
;	 ; Reimposta write mode 0
;	 mov  dx,03CEh
;	 mov  al,005h
;	 out  dx,al
;	 inc  dx
;	 in   al,dx
;	 and  al,0FCh
;	 out  dx,al

	; Ripristina registri
	pop  bp
	pop  es
	pop  ds
	pop  di
	pop  si
	pop  dx
	pop  cx
	pop  bx
	pop  ax
	ret
Flip	endp

;
; Programma principale
;
main	proc near
;	 ;
;	 ; Test sul tipo di CPU (386 minimo)
;	 ;
;	 push sp
;	 pop  dx
;	 cmp  dx,sp
;	 je   @@No8086
;@@BadCPU:
;	 mov  dx,offset CPUErr
;	 jmp  Error
;@@No8086:
;	 mov  bx,offset LMask
;	 sgdt [bx]
;	 cmp  byte ptr [bx+5],0
;	 jne  @@BadCPU
	;
	; Test sul tipo CPU
	;
	pushf
	mov   ax,07000h
	push  ax
	popf
	sti
	pushf
	pop   ax
	popf
	test  ax,07000h
	jne   @@Ok386
	mov   bx,offset CPUErr
	jmp   Error
@@Ok386:
	;
	; Rilascia tutto tranne 64k+256 bytes
	;
	mov  bx,(65536+256)/16
	mov  ah,04Ah
	int  021h
	;
	; Alloca: 64k per plasma clouds
	;	  64k per light model Gouraud
	;	  64k per light model Phong
	;	  4k  per dda
	;	  4k  per sine table
	;
	mov  bx,(65536+65536+65536+4096+4096)/16
	mov  ah,048h
	int  021h
	jnc  @@MemOK
	mov  dx,offset OOM
	jmp  Error
@@MemOk:
	mov  plasma,ax
	add  ax,65536/16
	mov  lmod,ax
	add  ax,65536/16
	mov  phong,ax
	add  ax,65536/16
	mov  ddas,ax
	add  ax,4096/16
	mov  sine,ax

	;
	; Entra in modalita' grafica 320 x 200 x 256 x 4P
	;

;	 ;
;	 ; Off graduale
;	 ;
;	 mov  dx,03C7h		 ; legge la palette attuale
;	 mov  al,0
;	 out  dx,al
;	 mov  dx,03C9h
;	 mov  cx,768
;	 mov  es,sine		 ; uso temporaneo
;	 xor  di,di
;	 rep  insb
;	 mov  bx,03F3Fh 	 ; bl = moltiplicatore, bh = divisore
;@@Off1:
;	 mov  dx,03C8h
;	 mov  al,0
;	 out  dx,al
;	 inc  dx
;	 xor  di,di
;	 mov  cx,768
;@@Off2:
;	 mov  al,es:[di]	 ; carica valore originale
;	 mul  bl		 ; scala il valore letto
;	 div  bh
;	 out  dx,al		 ; imposta palette
;	 inc  di		 ; passa alla prossima componente
;	 loop @@Off2
;
;	 call VRWait
;	 dec  bl		 ; decrementa luminosita'
;	 jge  @@Off1		 ; sino a zero incluso


	;
	; Impostazione modo grafico
	;
	mov  ax,00013h			; Modalita' base
	int  010h

	;
	; Calcola plasma texture & light model
	;
	call PlasmaC
	call Light

	mov  dx,03DAh			; Attende un vertical retrace
@@Wait1:
	in   al,dx
	test al,8
	je   @@Wait1

	mov  dx,003D4h			; VGA custom mode
	mov  ax,00014h
	out  dx,ax
	mov  ax,0E317h
	out  dx,ax
	mov  dx,003C4h
	mov  ax,00604h
	out  dx,ax

	mov  es,VidSeg			; Pulisce tutta la memoria
	mov  dx,003C4h
	mov  ax,00F02h
	out  dx,ax
	xor  di,di
	mov  cx,16384
	xor  eax,eax
	rep  stosd

	;
	; Attiva routine di interrupt
	;
	cli				; lavora a interrupt disabilitati!

	mov  ax,03508h			; legge I8 corrente
	int  021h
	mov  word ptr [oldi8],bx
	mov  word ptr [oldi8+2],es

	mov  dx,offset NewInt8		; imposta nuovo I8
	mov  ax,02508h
	int  021h

	mov  al,036h			; velocizza timer
	out  043h,al
	mov  ax,MixFreq
	out  040h,al
	mov  al,ah
	out  040h,al

	sti

	;
	; Inizializzazioni
	;
	call InitPoly

;	 ;
;	 ; Riempe lo sfondo di pixel con colore 16+random(16)
;	 ;
;	 xor  ax,ax
;	 mov  bx,0
;@@1:	 call rand
;	 and  dl,15
;	 or   dl,16
;	 mov  cl,dl
;	 call PutPixel		 ; disegno su pagina 0
;	 xor  basea,3*16384
;	 call PutPixel		 ; disegno su pagina 3
;	 xor  basea,3*16384
;	 inc  ax		 ; loop su tutti i pixel
;	 cmp  ax,320
;	 jne  @@1
;	 xor  ax,ax
;	 inc  bx
;	 cmp  bx,200
;	 jne  @@1

;	 ;
;	 ; Imposta palette per marmo
;	 ;
;	 cli
;	 mov  dx,03C8h
;	 mov  al,32
;	 out  dx,al
;	 mov  cl,0
;	 inc  dx
;@@Loop4:
;	 mov  al,cl
;	 shr  al,1
;	 mov  ah,al
;	 add  ax,01018h
;	 mov  bl,cl
;	 shr  bl,1
;	 add  bl,010h
;	 out  dx,al
;	 mov  al,ah
;	 out  dx,al
;	 mov  al,bl
;	 out  dx,al
;	 inc  cl
;	 cmp  cl,64
;	 jne  @@Loop4
;
;	 sti

	;
	; Disegna un toro rotante
	;
	call Palette
	call CalcSine
	mov  Time,0
	mov  banx,320
@@Loop5:
	;
	; Ricacola (eventualmente) il toro
	;
	call Torus

	;
	; Imposta gli angoli di rotazione
	;
	cli
	mov  ax,AA0
	and  ax,0FFFEh
	mov  AA,ax
	mov  ax,BB0
	and  ax,0FFFEh
	mov  BB,ax
	mov  ax,CC0
	and  ax,0FFFEh
	mov  CC,ax
	sti

	;
	; Disegna
	;
	call Draw
	call Flip

	;
	; Controlla un eventuale adeguamento numero facce & raggio principale
	;
	cmp  phase,1
	jl   @@NoFrizz
	cmp  r2,384	    ;384
	jge  @@NoRad
	add  r2,8
	inc  TorFlag
@@NoRad:
	cmp  torn,12	    ;12
	jge  @@NoTORN
	inc  torn
	inc  TorFlag
@@NoTorn:
	cmp  torm,24	    ;24
	jge  @@NoFrizz
	inc  torm
	inc  TorFlag
@@NoFrizz:
	;
	; Tempo scaduto ?
	;
	mov  bx,phase
	shl  bx,1
	mov  ax,Time
	cmp  word ptr Events[bx],ax
	jge  @@NotExpired
	;
	; Passa alla prossima fase
	;
	inc  phase
	cmp  phase,PHASES
	jge  @@End
;	inc  TorFlag
	cmp  phase,PHASES-1
	jne  @@NotExpired
	mov  StarDir,-1
	mov  StarRad,320+200

@@NotExpired:

	;
	; Attende un tasto
	;
@@Wait:
	mov  ax,0100h
	int  016h
	je   @@Loop5

@@End:

	;
	; Reimposta vecchio int8
	;
	cli				; interrupt disabilitati!
	mov  dx,word ptr [oldi8]
	push ds
	push word ptr [oldi8+2]
	pop  ds
	mov  ax,02508h
	int  021h
	pop  ds

	mov  al,036h			; rallenta il timer
	out  043h,al
	mov  al,0
	out  040h,al
	out  040h,al
	sti

;	 ;
;	 ; Stampa il tempo trascorso o il numero di frame
;	 ;
;	 mov  cx,5
;	 mov  di,4
;	 mov  ax,nFrame
;	 mov  si,10
;@@Print:
;	 mov  dx,0
;	 div  si
;	 add  dl,48
;	 mov  byte ptr ByeBye[di],dl
;	 dec  di
;	 loop @@Print
;	 mov  byte ptr ByeBye[5],'$'

;	 ;
;	 ; Snapshot!
;	 ;
;	 mov  dx,offset FileName
;	 mov  ah,03Ch
;	 mov  cx,0
;	 int  021h
;	 jc   @@Error1
;
;	 mov  di,00004h 	     ; Plane 0
;	 mov  bx,ax		     ; File handle
;	 mov  si,0A000h
;@@PlaneLoop:
;	 mov  dx,03CEh		     ; Read map select
;	 mov  ax,di
;	 out  dx,ax
;	 mov  dx,basea
;	 sub  dx,16384		     ; Last frame!
;	 mov  cx,16000		     ; Full plane
;	 push ds
;	 mov  ds,si
;	 mov  ah,040h		     ; Write
;	 int  021h
;	 pop  ds
;	 jc   @@Error1
;	 add  di,0100h
;	 cmp  di,0404h
;	 jne  @@PlaneLoop
;	 mov  ah,03Eh
;	 int  021h
; @@Error1:
	mov  dx,offset ByeBye
Error:
	mov  ax,00003h
	int  010h
	mov  ah,09h
	int  021h
	mov  ax,04C00h
	int  021h
main	endp

;FileName db 'TORUS.IMG',0

	;
	; Tabelle precalcolate di accesso alla memoria video
	; (1600 bytes)
	;
LMask	equ  $			; 320 bytes per mascheratura sinistra
RMask	equ  $+320		; 320 bytes per mascheratura destra
PMask	equ  $+640		; 320 bytes per mascheratura pixel
HOffs	equ  $+960		; 640 bytes per calcolo offset

	;
	; Area di comodo per sort 3d (750 poligoni x 2 word = 3000 bytes)
	;
Polys	equ  $+1600
	;
	; Punti solido (x,y,z,nx,ny,nz,xs,ys,zs,nxs,nys,nzs,rxs,rys,rzs)
	; 750 punti x 15 word = 22500 bytes
	;
Pts	equ  $+4600
	;
	; Poligoni (n,col,p1,a1,b1,p2,a2,b2,...)
	; 750 poligoni da 4 punti x 14 word = 21000 bytes
	;
Fpt	equ  $+27100

Last	equ  $+48100

code	ends

	end  startup
